package ch4.parClasseConcrete;

import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.MapKey;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Transient;

@Entity(name="ch4.parClasseConcrete.Yeam")
@Table(name="CONCRETE_TEAM")
public class Team {
	@Id
	@GeneratedValue(
			strategy=GenerationType.AUTO)
	@Column(name="TEAM_ID")
	private int id;
	
	//dcommenter pour mettre en lumire l'impossibilit d'association polymorphique
	//@OneToMany
	@Transient
	private Set<Person> staff = new HashSet<Person>();
	

	@OneToOne
	private Coach coach;
	
	@Transient
	private int nbLostGames;

	private String name;

	public int getId()
	{
		return id;
	}

	public void setId(int id)
	{
		this.id = id;
	}

	public String getName()
	{
		return name;
	}

	public void setName(String name)
	{
		this.name = name;
	}

	public Coach getCoach() {
		return coach;
	}

	public void setCoach(Coach coach) {
		this.coach = coach;
	}

	public int getNbLostGames() {
		return nbLostGames;
	}

	public void setNbLostGames(int nbLostGames) {
		this.nbLostGames = nbLostGames;
	}

	public Set<Person> getStaff() {
		return staff;
	}

	public void setStaff(Set<Person> staff) {
		this.staff = staff;
	}

}
