package ch4Tests.demoManyToMany;

import javax.naming.InitialContext;
import javax.persistence.EntityManager;
import javax.transaction.TransactionManager;

import junit.framework.Test;

import org.jboss.deployers.spi.DeploymentException;
import org.jboss.embedded.Bootstrap;
import org.jboss.embedded.junit.BaseTestCase;
import org.jboss.virtual.plugins.context.vfs.AssembledContextFactory;
import org.jboss.virtual.plugins.context.vfs.AssembledDirectory;

import ch4.demoCompositeElement.Coach;
import ch4.demoCompositeElement.CoachTeam;
import ch4.demoCompositeElement.Team;



public class Ch4TestCase extends BaseTestCase
{
	public Ch4TestCase()
	{
		super("Ch3TestCase");
	}

	private static AssembledDirectory jar;



	//public static void deploy()
	public static void deploy()
	{
		jar = AssembledContextFactory.getInstance().create("Ch3TestCase.jar");

		jar.addClass(Coach.class);
		jar.addClass(Team.class);
		jar.addClass(CoachTeam.class);
		
		jar.addResource("myDS-ds.xml");
		jar.mkdir("META-INF").addResource("eyrolles-persistence.xml", "persistence.xml");

		try
		{
			Bootstrap.getInstance().deploy(jar);
		}
		catch (DeploymentException e)
		{
			throw new RuntimeException("Unable to deploy", e);
		}
	}

	public static void undeploy()
	{
		try
		{
			Bootstrap.getInstance().undeploy(jar);
			AssembledContextFactory.getInstance().remove(jar);
			jar = null;
		}
		catch (DeploymentException e)
		{
			throw new RuntimeException("Unable to undeploy", e);
		}
	}



	public static Test suite()
	{
		return preProcessedTest(Ch4TestCase.class);
	}

	public void test() throws Exception
	{
		EntityManager em = (EntityManager) new InitialContext().lookup("java:/EntityManagers/eyrollesEntityManager");

		TransactionManager tm = (TransactionManager) new InitialContext().lookup("java:/TransactionManager");
		
		// instanciation d'une Team et d'un Coach
		Team team = new Team();
		team.setName("OM");
		Coach coach = new Coach();
		coach.setName("coach");
		tm.begin();
 		em.persist(team);   
		em.persist(coach);  
		tm.commit();
		// ici les deux instances ne sont pas en relation
		// elles sont aussi dtaches

		// cration du lien
		tm.begin();
		CoachTeam ct = new CoachTeam();
		ct.setCoach(coach);
		// ligne la plus importante
		coach.getCoachTeams().add(ct);
		ct.setTeam(team);
		ct.setDirectorName("the director");
		// rendre les modifications persistantes,
		// les entits sont dtaches, ceci n'est pas
		// ralis de manire transparente
		em.merge(coach);
		tm.commit();



	}
}
